// Settings

extern int view_backgroundarea, view_gamearea, generate_random;
extern int no_sound, no_music, debug, inawin, no_parallax, no_blit_hardware;
extern int names_visible, no_armor, low_detail_level, view_grid, snap_to_grid;
extern int random_placement_platform, random_placement_any, random_placement_on;
extern int random_placement_between, random_placement_under;
extern char temp_path[], autosave_level[], clipboard_level[];
extern double gamma;

// Windows

extern class CBlasterApp theApp;

// Graphics related

extern LPDIRECTDRAW4 DD;
extern LPDIRECTDRAWSURFACE4 screen, backbuffer;
extern DDPIXELFORMAT pixelformat;
extern DDCAPS hardware_caps;
extern LPDIRECTDRAWPALETTE palette;
extern LPPALETTEENTRY rgb_table;
extern LPDIRECTDRAWCLIPPER clipper;
extern int color_table_this_mode[256];
extern HFONT tinyfont, normalfont, largefont;
extern int black, gray, white, red, green, blue, yellow, mask_color;
extern char *cmap_gray;
extern int hardware_blit_caps;

// Input related

#define kMaxJoys	4

extern LPDIRECTINPUT DI;
extern char key[256];
extern DWORD key_up[3], key_down[3], key_left[3], key_right[3], key_fire[3];
extern char joy_str[kMaxJoys][MAX_PATH];
extern GUID *joy_guid[kMaxJoys];
extern DWORD joy_fire[kMaxJoys], joy_jetpack[kMaxJoys], joy_mine[kMaxJoys];
extern int reverse_mouse;

// Sound related

extern LPDIRECTSOUND DS;

// Background related

extern class cSurface *back_surface, *game_surface, *left_surface, *right_surface, *info_surface;
extern fix scroll_speed;

// Gameloop related

#define kMaxPlayers		8

extern int end_game;
extern class cPlayer *first_at_end;
extern char pl_name[kMaxPlayers][16];
extern int pl_selected[kMaxPlayers];

// Quickstart related

extern int started_with_quickstart;
extern char quickstart_level[];

// Standard things for use in the game

extern class cProperties *mine, *bullet, *rocket, *thumper, *water_drop;
extern class cImage *deaths_icon, *mine_icon, *spread_gun_icon, *jetpack_icon, *rocket_icon, *thumper_icon, *in_game_pointer;
extern class cBMP *backgr, *ambient1, *ambient2;
extern class cRandomList bubble_list, crate_contents_list, inflamable_contents_list, machine_contents_list, parts_list;

// Objects

extern class cObjectTypes objtypes[];
extern class cData *data;
extern class cBMP *bitmaps;
extern class cWAV *wave;
extern class cProperties *props;
extern class cPlayer *players;
extern class cBubble *bubbles;
extern class cParts *parts;
extern class cEffect *effects;
extern class cDisaster *disaster;
extern class cText *texts;
extern class cController *controllers;
extern class cScore *scores;
extern class cDisplayable *images_left, *images_right;
extern class cText *texts_left, *texts_right;
extern class cLevel *level;

// Objects that are put in different lists

extern class cScenery *scenery_back1, *scenery_back1_belowscreen, *scenery_back1_abovescreen;
extern class cScenery *scenery_back2, *scenery_back2_belowscreen, *scenery_back2_abovescreen;
extern class cScenery *scenery_game1, *scenery_game1_belowscreen, *scenery_game1_abovescreen;
extern class cScenery *scenery_game2, *scenery_game2_belowscreen, *scenery_game2_abovescreen;
extern class cScenery *scenery_game3, *scenery_game3_belowscreen, *scenery_game3_abovescreen;
extern class cStructure *structures, *structures_belowscreen, *structures_abovescreen;
extern class cStairs *stairs, *stairs_belowscreen, *stairs_abovescreen;
extern class cBonus *bonus, *bonus_belowscreen, *bonus_abovescreen;
extern class cWeapon *weapons, *weapons_belowscreen, *weapons_abovescreen;

// Editor

extern class cEditable *editables, *left_editable;
extern int selectionbox_active;